#
# Conditional build:
%bcond_without	tests		# build without tests
%bcond_without	web		# make web package

# build "web" with 7.4 build
%if 0%{?_pld_builder:1} && "%{?php_suffix}" != "74"
%undefine	with_web
%endif

%define		php_name	php%{?php_suffix}
%define		modname	memcache
%define		php_min_version 5.0.0
%define		commit e702b5f91
Summary:	%{modname} - a memcached extension
Summary(pl.UTF-8):	%{modname} - rozszerzenie memcached
Name:		%{php_name}-pecl-%{modname}
Version:	8.0
Release:	1
License:	PHP 3.01
Group:		Development/Languages/PHP
Source0:	https://pecl.php.net/get/memcache-%{version}.tgz
# Source0-md5:	ff34dc5ae1fa5b90b5bbeef56d302546
Source1:	%{modname}.ini
Source2:	%{modname}-apache.conf
Source3:	%{modname}-lighttpd.conf
Source4:	config.php
Patch0:		%{modname}-webapp.patch
Patch1:		tests.patch
URL:		https://pecl.php.net/package/memcache
BuildRequires:	%{php_name}-devel >= 3:7.0.0
BuildRequires:	%{php_name}-pcre
BuildRequires:	%{php_name}-session
BuildRequires:	%{php_name}-simplexml
BuildRequires:	%{php_name}-spl
BuildRequires:	%{php_name}-xml
BuildRequires:	php-packagexml2cl
BuildRequires:	rpm-php-pearprov >= 4.4.2-11
BuildRequires:	rpmbuild(macros) >= 1.650
%if %{with tests}
BuildRequires:	%{php_name}-cli
BuildRequires:	memcached
%endif
%{?requires_php_extension}
Requires:	%{php_name}-session
Requires:	%{php_name}-zlib
Suggests:	memcached
Provides:	php(memcache) = %{version}
Obsoletes:	php-pecl-memcache < 3.0.8-5
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_webapps	/etc/webapps
%define		_webapp		%{modname}
%define		_sysconfdir	%{_webapps}/%{_webapp}
%define		_appdir		%{_datadir}/%{_webapp}

# bad depsolver
%define		_noautopear	pear

# put it together for rpmbuild
%define		_noautoreq	%{?_noautophp} %{?_noautopear}

%description
Memcached is a caching daemon designed especially for dynamic web
applications to decrease database load by storing objects in memory.

This extension allows you to work with memcached through handy OO and
procedural interfaces.

%description -l pl.UTF-8
Memcached to zaprojektowany dla dynamicznych aplikacji internetowych
daemon cachujący mający za zadanie zmniejszenie obciążenia bazy danych
przez przechowywanie w pamięci obiektów.

To rozszerzenie umożliwia pracę z memcached za pomocą poręcznego
zorientowanego obiektowo (oraz przez procedury) interfejsu.

%package -n php-pecl-memcache-web
Summary:	Web interface for memcache
Group:		Libraries
# does not require extension itself
Requires:	php(core) >= %{php_min_version}
Requires:	php(date)
Requires:	php(gd)
Requires:	php(pcre)
Requires:	webapps
Requires:	webserver(php) >= 5.0
Obsoletes:	php70-pecl-memcache-web < 4.0.5.1-2
Obsoletes:	php71-pecl-memcache-web < 4.0.5.1-2
Obsoletes:	php72-pecl-memcache-web < 4.0.5.1-2
Obsoletes:	php73-pecl-memcache-web < 4.0.5.1-2
Obsoletes:	php74-pecl-memcache-web < 4.0.5.1-2
%if "%{_rpmversion}" >= "5"
BuildArch:	noarch
%endif

%description -n php-pecl-memcache-web
Via this web interface script you can manage and view statistics of
memcache.

%prep
%setup -qc
mv %{modname}-*/* .
%patch0 -p1
%patch1 -p1

cat <<'EOF' > run-tests.sh
#!/bin/sh
export NO_INTERACTION=1 REPORT_EXIT_STATUS=1 MALLOC_CHECK_=2
exec %{__make} test \
	PHP_EXECUTABLE=%{__php} \
%if "%php_major_version.%php_minor_version" >= "7.4"
	PHP_TEST_SHARED_SYSTEM_EXTENSIONS="simplexml session" \
%else
	PHP_TEST_SHARED_SYSTEM_EXTENSIONS="pcre spl simplexml session" \
%endif
	RUN_TESTS_SETTINGS="-q $*"
EOF
chmod +x run-tests.sh

# skip failed tests
die() {
	echo >&2 "$*"
	exit 1
}
xfail() {
	set +x
	while read s; do
		t=$(echo "$s" | sed -rne 's/.+\[(.+)\]/\1/p')

		test -f "$t" || die "Missing $t"
		echo >&2 "XFAIL: $s"
		cat >> $t <<-EOF

		--XFAIL--
		Skip
		EOF
	done
}

xfail <<'EOF'
memcache->addServer() [tests/019.phpt]
memcache->set()/memcache->get() with multiple keys and load balancing [tests/020.phpt]
memcache->getExtendedStats() [tests/022.phpt]
memcache_get_extended_stats() [tests/022a.phpt]
memcache->delete() with load balancing [tests/023.phpt]
memcache->increment() with load balancing [tests/025.phpt]
memcache->delete() with load balancing [tests/026.phpt]
memcache->addServer() adding server in failed mode [tests/031.phpt]
memcache->getServerStatus(), memcache->setServerParams() [tests/032.phpt]
memcache::connect() with unix domain socket [tests/035.phpt]
ini_set('session.save_handler') [tests/036.phpt]
ini_set('session.save_path') [tests/036b.phpt]
memcache->increment()/decrement() with multiple keys [tests/040.phpt]
memcache->delete() with multiple keys [tests/041.phpt]
memcache->set() with multiple values [tests/042.phpt]
ini_set('memcache.redundancy') [tests/043.phpt]
ini_set('memcache.session_redundancy') [tests/044.phpt]
hash strategies and functions [tests/046.phpt]
ini_set('session.save_handler') with unix domain socket [tests/053.phpt]
memcache multi host save path function [tests/bug73539.phpt]
session_regenerate_id() should not cause fatal error [tests/githubbug13.phpt]
EOF

%build
packagexml2cl package.xml > ChangeLog
phpize
%configure \
	--with-zlib-dir=/usr
%{__make}

# simple module load test
%{__php} -n -q \
	-d extension_dir=modules \
%if "%php_major_version.%php_minor_version" >= "7.4"
	-d extension=%{php_extensiondir}/simplexml.so \
	-d extension=%{php_extensiondir}/session.so \
%else
	-d extension=%{php_extensiondir}/pcre.so \
	-d extension=%{php_extensiondir}/spl.so \
	-d extension=%{php_extensiondir}/simplexml.so \
	-d extension=%{php_extensiondir}/session.so \
%endif
	-d extension=%{modname}.so \
	-m > modules.log
grep %{modname} modules.log

%if %{with tests}
# Launch the Memcached service and stop it on exit
domainsocket=$PWD/memcached.sock
%{_sbindir}/memcached -p 11211 -U 11211 -d -P $PWD/memcached.pid
%{_sbindir}/memcached -s $domainsocket -d -P $PWD/memcached-udp.pid
trap 'kill $(cat memcached.pid memcached-udp.pid)' EXIT INT

./run-tests.sh --show-diff
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{php_sysconfdir}/conf.d,%{php_extensiondir},%{_examplesdir}/%{name}-%{version}}
install -p modules/%{modname}.so $RPM_BUILD_ROOT%{php_extensiondir}
# we use "session_" prefix in inifile to get loader *after* session extension
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{php_sysconfdir}/conf.d/session_%{modname}.ini
cp -p example.php $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

%if %{with web}
install -d $RPM_BUILD_ROOT{%{_sysconfdir},%{_appdir}}
cp -p memcache.php $RPM_BUILD_ROOT%{_appdir}
cp -p %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/config.php
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/apache.conf
cp -p $RPM_BUILD_ROOT%{_sysconfdir}/{apache,httpd}.conf
cp -p %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/lighttpd.conf
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%php_webserver_restart

%postun
if [ "$1" = 0 ]; then
	%php_webserver_restart
fi

%triggerpostun -- %{name} < 3.0.4-2
if [ -f %{php_sysconfdir}/conf.d/%{modname}.ini.rpmsave ]; then
	echo >&2 "Restoring old config: %{modname}.ini.rpmsave -> session_%{modname}.ini in %{php_sysconfdir}/conf.d"
	cp -f %{php_sysconfdir}/conf.d/session_%{modname}.ini{,.rpmnew}
	mv -f %{php_sysconfdir}/conf.d/{%{modname}.ini.rpmsave,session_%{modname}.ini}
	%php_webserver_restart
fi

%triggerin -n php-pecl-memcache-web -- apache1 < 1.3.37-3, apache1-base
%webapp_register apache %{_webapp}

%triggerun -n php-pecl-memcache-web -- apache1 < 1.3.37-3, apache1-base
%webapp_unregister apache %{_webapp}

%triggerin -n php-pecl-memcache-web -- apache < 2.2.0, apache-base
%webapp_register httpd %{_webapp}

%triggerun -n php-pecl-memcache-web -- apache < 2.2.0, apache-base
%webapp_unregister httpd %{_webapp}

%triggerin -n php-pecl-memcache-web -- lighttpd
%webapp_register lighttpd %{_webapp}

%triggerun -n php-pecl-memcache-web -- lighttpd
%webapp_unregister lighttpd %{_webapp}

%files
%defattr(644,root,root,755)
%doc CREDITS README ChangeLog
%config(noreplace) %verify(not md5 mtime size) %{php_sysconfdir}/conf.d/session_%{modname}.ini
%attr(755,root,root) %{php_extensiondir}/%{modname}.so
%{_examplesdir}/%{name}-%{version}

%if %{with web}
%files -n php-pecl-memcache-web
%defattr(644,root,root,755)
%dir %attr(750,root,http) %{_sysconfdir}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/apache.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/httpd.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/lighttpd.conf
%attr(640,root,http) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/config.php
%{_appdir}
%endif
%changelog
* Wed Dec 16 2020 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/php-pecl-memcache.git;a=log;h=auto/th/php-pecl-memcache-8.0-1

* Tue Dec 15 2020 Elan Ruusamäe <glen@pld-linux.org> dc9c128
- Up to 8.0, adds php 8.0 support

* Tue Dec 15 2020 Elan Ruusamäe <glen@pld-linux.org> 8f90994
- Up to 4.0.5.2

* Mon May 04 2020 Elan Ruusamäe <glen@pld-linux.org> e749f62
- Build web package standalone of extension version

* Sat Jan 25 2020 Jan Rękorajski <baggins@pld-linux.org> 0b46688
- drop obsolete and outdated manual inclusion of rpm macros

* Thu Dec 19 2019 Elan Ruusamäe <glen@pld-linux.org> a92c026
- Update for missing tests/044b.phpt

* Thu Dec 19 2019 Elan Ruusamäe <glen@pld-linux.org> 3ed6454
- up to 4.0.5.1

* Wed Aug 21 2019 Elan Ruusamäe <glen@pld-linux.org> cb9f58e
- Add memcache with udp listen for tests

* Tue Aug 20 2019 Elan Ruusamäe <glen@pld-linux.org> 746511d
- fix self-test on php 7.4; always do module load test

* Fri Aug 16 2019 Elan Ruusamäe <glen@pld-linux.org> f00d600
- up to 4.0.4

* Sat May 11 2019 Elan Ruusamäe <glen@pld-linux.org> 31f4af4
- update failed tests

* Sat May 11 2019 Elan Ruusamäe <glen@pld-linux.org> 9600d33
- php 5.2 deps

* Sat May 11 2019 Elan Ruusamäe <glen@pld-linux.org> 2847bd4
- reset failed tests

* Fri May 10 2019 Elan Ruusamäe <glen@pld-linux.org> f148f58
- up to 4.0.3

* Tue Nov 13 2018 Elan Ruusamäe <glen@pld-linux.org> 2b5f773
- rel 3; php 7.3 support

* Tue Nov 13 2018 Elan Ruusamäe <glen@pld-linux.org> 7b17d00
- [PATCH] fix for PHP 7.3 + fix build warnings

* Tue Nov 13 2018 Elan Ruusamäe <glen@pld-linux.org> 4b53237
- [PATCH] Fix #23 Failed to read session data with 7.1/7.2

* Tue Dec 05 2017 Elan Ruusamäe <glen@pld-linux.org> ea2e044
- tests/bug73539.phpt fails on most versions on builders

* Tue Dec 05 2017 Elan Ruusamäe <glen@pld-linux.org> 7362daf
- up to e702b5f91 snapshot

* Mon Dec 12 2016 Elan Ruusamäe <glen@delfi.ee> b5fd909
- strange keys [tests/005.phpt] fails on php 7.1

* Wed Nov 23 2016 Elan Ruusamäe <glen@delfi.ee> c6406d1
- repated failures for tests/029.phpt

